trait CmRDT {
  type State
  type Type
  type Operation
  def query(s: State): Type
  def updateLocal(s: State, op: Operation): State
  def updateExternal(s: State, op: Operation): State
}

object CmRDT {
  object Counter extends CmRDT {
    case class Inc(m: Int)

    type State = Int
    type Type = Int
    type Operation = Inc

    def query(s: State): Type = s

    def updateLocal(s: State, op: Operation) = s + op.m

    def updateExternal(s: State, op: Operation) = s + op.m
  }

  type VectorClock = Vector[Int]

  def compareVectorClock(a: VectorClock, b: VectorClock): Boolean =
<<<<<<< Updated upstream
    a.zip(b).find{ case (a,b) => a != b }.forall{ case (a,b) => a > b}

  def mergeVectorClock(a: VectorClock, b: VectorClock): VectorClock =
    a.zip(b).map { case (a,b) => a max b}
=======
    a.zip(b).find{ case (a,b) => a != b }.forall{ case (a,b) => a > b }

  def mergeVectorClock(a: VectorClock, b: VectorClock): VectorClock =
    a.zip(b).map { case (a,b) => a max b }
>>>>>>> Stashed changes

  class LWWRegister[T] extends CmRDT {
    case class Write(t: VectorClock, value: T)

    case class RegisterState(
      id: Int,
      time: VectorClock,
      value: T
    )

    type State = RegisterState
    type Type = T
    type Operation = Write

    def query(s: State): Type = s.value

    def updateLocal(s: State, op: Operation) =
      s.copy(time = op.t, value = op.value)

    def updateExternal(s: State, op: Operation) =
      if (compareVectorClock(op.t, s.time)) s.copy(time = mergeVectorClock(s.time,op.t), value = op.value)
      else s.copy(time = mergeVectorClock(s.time,op.t))
  }
}