trait CvRDT {
  type State
  type Type
  type Operation
<<<<<<< Updated upstream
=======

>>>>>>> Stashed changes
  def query(s: State): Type
  def update(s: State, op: Operation): State
  def merge(s1: State, s2: State): State
}

object CvRDT {
  object Counter extends CvRDT {
    case class Inc(m: Int)

    type State = Int
    type Type = Int
    type Operation = Inc

    def query(s: State): Type = s
<<<<<<< Updated upstream

    def update(s: State, op: Operation) = s + op.m

    def merge(s1: State, s2: State) = s1 max s2
  }


  object PNCounter extends CvRDT {

    sealed trait PNOperation

    case class Inc(m: Int) extends PNOperation

    case class Dec(m: Int) extends PNOperation

    type State = (Int, Int)
    type Type = Int
    type Operation = PNOperation

    def query(s: State): Type = s._1 - s._2

    def update(s: State, op: Operation) = op match {
      case Inc(m) => (s._1 + m, s._2)
      case Dec(m) => (s._1, s._2 + m)
    }

    def merge(s1: State, s2: State) = (s1._1 max s2._1, s1._2 max s2._2)
  }

  class GrowOnlySet[T] extends CvRDT {

=======
    def update(s: State, op: Operation) = s + op.m
    def merge(s1: State, s2: State) = s1 max s2
  }

  abstract class CombinedCvRDT[A <: CvRDT, B <: CvRDT](val a: A, val b: B) extends CvRDT {
    type State = (a.State,b.State)
    def merge(s1: State, s2: State) =
      (a.merge(s1._1,s2._1),b.merge(s1._2,s2._2))
  }

  object PNCounter extends CombinedCvRDT(Counter,Counter) {
    sealed trait PNOperation
    case class Inc(m: Int) extends PNOperation
    case class Dec(m: Int) extends PNOperation

    type Type = Int
    type Operation = PNOperation

    def query(s: State): Type = a.query(s._1) - b.query(s._2)
    def update(s: State, op: Operation) = op match {
      case Inc(m) => (a.update(s._1, Counter.Inc(m)), s._2)
      case Dec(m) => (s._1, b.update(s._2, Counter.Inc(m)))
    }
  }

  class GrowOnlySet[T] extends CvRDT {
>>>>>>> Stashed changes
    case class Add(elem: T)

    type State = Set[T]
    type Type = Set[T]
    type Operation = Add

    def query(s: State): Type = s
<<<<<<< Updated upstream

    def update(s: State, op: Operation) = s + op.elem

    def merge(s1: State, s2: State) = s1 ++ s2
  }

  class TwoPhaseSet[T] extends CvRDT {

    sealed trait TwoPhaseSetOperation

    case class Add(elem: T) extends TwoPhaseSetOperation

    case class Remove(elem: T) extends TwoPhaseSetOperation

    type State = (Set[T], Set[T])
=======
    def update(s: State, op: Operation) = s + op.elem
    def merge(s1: State, s2: State) = s1 ++ s2
  }

  class TwoPhaseSet[T] extends CombinedCvRDT(new GrowOnlySet[T], new GrowOnlySet[T]) {
    sealed trait TwoPhaseSetOperation
    case class Add(elem: T) extends TwoPhaseSetOperation
    case class Remove(elem: T) extends TwoPhaseSetOperation

>>>>>>> Stashed changes
    type Type = Set[T]
    type Operation = TwoPhaseSetOperation

    def query(s: State): Type = s._1 -- s._2
<<<<<<< Updated upstream

    def update(s: State, op: Operation) = op match {
      case Add(elem) => (s._1 + elem, s._2)
      case Remove(elem) => (s._1, s._2 + elem)
    }

    def merge(s1: State, s2: State) = (s1._1 ++ s2._1, s1._2 ++ s2._2)
=======
    def update(s: State, op: Operation) = op match {
      case Add(elem) => (a.update(s._1,a.Add(elem)), s._2)
      case Remove(elem) => (s._1, b.update(s._2,b.Add(elem)))
    }
>>>>>>> Stashed changes
  }
}